# DescribeVpcs

## 1. API Description

This API (DescribeVpcs) is used to query the details of one or more global VPCs. You can filter the query results with the VPC ID and name.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                                      | Description                                                                                                                                                  |
| --------------- | -------- | ----------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| vpcIds          | No       | Array of String                                                                           | Global VPC IDs.                                                                                                                                              |
| name            | No       | String                                                                                    | <p>Global VPC name.</p><p>Fuzzy query is supported.</p>                                                                                                      |
| cidrBlock       | No       | String                                                                                    | <p>CIDR block of the subnet.</p><p>Fuzzy query is supported.</p>                                                                                             |
| pageSize        | No       | Integer                                                                                   | <p>Number of items in the current page result.</p><p>Default value: 20;</p><p>Maximum value: 1000.</p><p>Value range: \[1, 1000]</p><p>Default value: 20</p> |
| pageNum         | No       | Integer                                                                                   | <p>Number of pages returned.</p><p>Default value: 1.</p><p>Value range: \[1, +)</p><p>Default value: 1</p>                                                   |
| resourceGroupId | No       | String                                                                                    | Resource group id.                                                                                                                                           |
| tagKeys         | No       | Array of String                                                                           | <p>Query using tag keys.</p><p>A maximum of 20 tag keys can be used.</p>                                                                                     |
| tags            | No       | Array of [Tag](https://docs.console.zenlayer.com/api-reference/compute/datastructure#tag) | <p>Query using tags.</p><p>A maximum of 20 tags can be used.</p>                                                                                             |

## 3. Output Parameters

| Parameter Name | Type                                                                                              | Description                                                                                                           |
| -------------- | ------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                            | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                                           | Number of global VPCs meeting the filtering conditions.                                                               |
| dataSet        | Array of [VpcInfo](https://docs.console.zenlayer.com/api-reference/compute/datastructure#vpcinfo) | Information on global VPCs.                                                                                           |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query all the available global VPCs with a CIDR block of `10.0.0.0/24`.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeVpcs
<Common Request Params>

Request：
{
  "cidrBlock": "10.0.0.0/24",
  "pageSize": 10,
  "pageNum": 1
}

Response：
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
    "dataSet": [
      {
        "vpcId": "xxx",
        "name": "xxx",
        "cidrBlock": "10.0.0.0/8",
        "ipv6CidrBlock": "",
        "mtu": 1000,
        "isDefault": true,
        "createTime": "2022-01-01T01:00:00Z",
        "usageIpv4Count": 256,
        "securityGroupId": "xxx",
        "resourceGroup":{
          "resourceGroupId": "<resourceGroupId>",
          "resourceGroupName": "Test"
        },
        "tags":null
      }
    ],
    "totalCount": 1
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
